'
' Crowd scene with unique animations
' Petr Schreiber, 2009
'

#COMPILE EXE
#DIM ALL
#INCLUDE "GLFW.inc"     ' -- Header for GLFW translated by Jos Roca
                        ' -- Download from http://www.jose.it-berater.org/smfforum/index.php?topic=2814.0
#INCLUDE "MD2Plus.inc"

%howMany  = 20

FUNCTION PBMAIN () AS LONG

  LOCAL running AS LONG
  LOCAL dHDc AS DWORD
  LOCAL ColorDepthBits AS LONG
  LOCAL nWidth, nHeight AS LONG
  LOCAL nSpeed AS DOUBLE
  LOCAL t, t0, FrameRate AS DOUBLE
  LOCAL frames AS LONG
  nSpeed = 5

  ' -- Retrieve desktop bit depth
  dHdc = GetDC(%HWND_DESKTOP)
  ColorDepthBits = GetDeviceCaps( dHDc, %BITSPIXEL )
  ReleaseDC (%HWND_DESKTOP, dHdc)

  ' --
  glfwInit

  ' -- Attempt to create window at 640x480x32
  IF ISFALSE glfwOpenWindow(640, 480, 0, 0, 0, 0, ColorDepthBits, 0, %GLFW_WINDOW) THEN
     glfwTerminate
     EXIT FUNCTION
  END IF
  glfwSetWindowTitle("MD2 Model / Rendering crowd of"+STR$(%howMany)+" individuals")
  running = %TRUE

  ' -- Initialize lighting
  glEnable %GL_LIGHTING
  glEnable %GL_LIGHT0
  glEnable %GL_NORMALIZE
  glEnable %GL_AUTO_NORMAL
  glShadeModel %GL_SMOOTH
  glLightModeli %GL_LIGHT_MODEL_TWO_SIDE, 1


  ' -- Depth testing for proper triangle order
  glEnable %GL_DEPTH_TEST

  LOCAL i AS LONG
  FOR i = 1 TO %howMany
    ' -- Random model
    IF RND > 0.5 THEN
      MD2_Load(i, EXE.PATH$+"SampleModel/Dragon.MD2", EXE.PATH$+"SampleModel/Dragon.bmp")
    ELSE
      MD2_Load(i, EXE.PATH$+"SampleModel/Sydney.MD2", EXE.PATH$+"SampleModel/Sydney.bmp")
    END IF

    ' -- Set random animation
    MD2_LockAnimRangeByName(i, "run")''PARSE$( "run,crwalk", ",", RND(1,2)))

    ' -- Shift animation slightly
    MD2_AdvanceAnim(i, RND(10,30)/10)
  NEXT

  ' -- Prepare keys
  glfwEnable %GLFW_STICKY_KEYS

  t0 = gettickcount
  FrameRate = 1000

  ' -- Main loop
  WHILE running
      t = gettickcount

      ' Calculate and display FrameRate (frames per second)
      IF t - t0 > 1.0! OR frames = 0 THEN
         FrameRate = (frames / (t-t0)) * 1000
         t0 = t
         frames = 0
      END IF
      frames += 1
    glClear %GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT

    ' -- Select and setup the projection matrix
    glMatrixMode %GL_PROJECTION
    glLoadIdentity

    ' -- Calculate the aspect ratio of the window
    glfwGetWindowSize nWidth, nHeight
    gluPerspective 45.0!, nWidth/nHeight, 1.0!, 100.0!

    ' Select and setup the modelview matrix
    glMatrixMode %GL_MODELVIEW
    glLoadIdentity
      gluLookAt SIN(GetTickCount/1000)*5, 1, COS(GetTickCount/10000)*(%howMany*3/4), 0.1, 1, 0, 0, 1, 0

      FOR i = 1 TO %howMany
        glPushMatrix
          glTranslatef SIN(i),0,-%howMany/2+i
          glScalef 0.03, 0.03, 0.03
          ' -- Both advance animation and render
          MD2_DrawAnim(i, 5/MIN(FrameRate, 2000))
        glPopMatrix
      NEXT

    glfwSwapBuffers

    ' -- ESCAPE key to exit application
    running = NOT glfwGetKey(%GLFW_KEY_ESC) AND glfwGetWindowParam(%GLFW_OPENED)

  WEND

  ' -- Releasing models
  MD2_DeleteAll()
  glfwTerminate

END FUNCTION
