'
' The most basic skeleton for MD2 Plus
' Petr Schreiber, 2009
'

#COMPILE EXE
#DIM ALL

#INCLUDE "GLFW.inc"     ' -- Header for GLFW translated by Jos Roca
                        ' -- Download from http://www.jose.it-berater.org/smfforum/index.php?topic=2814.0
#INCLUDE "MD2Plus.inc"

%md2Model = 1

FUNCTION PBMAIN () AS LONG

  LOCAL running AS LONG
  LOCAL dHDc AS DWORD
  LOCAL ColorDepthBits AS LONG
  LOCAL nWidth, nHeight AS LONG

  ' -- Retrieve desktop bit depth
  dHdc = GetDC(%HWND_DESKTOP)
  ColorDepthBits = GetDeviceCaps( dHDc, %BITSPIXEL )
  ReleaseDC (%HWND_DESKTOP, dHdc)

  ' --
  glfwInit

  ' -- Attempt to create window at 640x480x32
  IF ISFALSE glfwOpenWindow(640, 480, 0, 0, 0, 0, ColorDepthBits, 0, %GLFW_WINDOW) THEN
     glfwTerminate
     EXIT FUNCTION
  END IF
  glfwSetWindowTitle("MD2 Model / Rendering first frame")
  running = %TRUE

  ' -- Initialize lighting
  glEnable %GL_LIGHTING
  glEnable %GL_LIGHT0
  glEnable %GL_NORMALIZE
  glEnable %GL_AUTO_NORMAL
  glShadeModel %GL_SMOOTH
  glLightModeli %GL_LIGHT_MODEL_TWO_SIDE, 1


  ' -- Depth testing for proper triangle order
  glEnable %GL_DEPTH_TEST

  MD2_Load(%md2Model, EXE.PATH$+"SampleModel/Dragon.MD2", EXE.PATH$+"SampleModel/Dragon.bmp")

  ' -- Prepare keys
  glfwEnable %GLFW_STICKY_KEYS

  ' -- Main loop
  WHILE running

    glClear %GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT

    ' -- Select and setup the projection matrix
    glMatrixMode %GL_PROJECTION
    glLoadIdentity

    ' -- Calculate the aspect ratio of the window
    glfwGetWindowSize nWidth, nHeight
    gluPerspective 45.0!, nWidth/nHeight, 1.0!, 100.0!

    ' Select and setup the modelview matrix
    glMatrixMode %GL_MODELVIEW
    glLoadIdentity
      gluLookAt 2, 2, 2, 0, 0, 0, 0, 1, 0
      glRotatef GetTickCount/10, 0, 1, 0

      glPushMatrix
        glScalef 0.03, 0.03, 0.03
        MD2_Draw(%md2Model, 1)
      glPopMatrix

    glfwSwapBuffers

    ' -- ESCAPE key to exit application
    running = NOT glfwGetKey(%GLFW_KEY_ESC) AND glfwGetWindowParam(%GLFW_OPENED)

  WEND

  ' -- Releasing model
  MD2_Delete(%md2Model)
  glfwTerminate

END FUNCTION
